/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/

CREATE TABLE "turtas" (
    "ID"           INTEGER NOT NULL,
    "Kodas"        VARCHAR(20),
    "Pavadinimas"  VARCHAR(150),
    "Tipas"        CHAR(1),
    "Data"         DATE,
    "Verte"        DECIMAL(12,2),
    "PVM"          DECIMAL(12,2),
    "DokID"        INTEGER,
    "Pastabos"     VARCHAR(100),
    "OpData"       DATE,
    "SaskNr"       VARCHAR(20),
    "InvKodas"     VARCHAR(20),
    "LikVerte"     DECIMAL(12,2),
    "Nudev"        DECIMAL(12,2),
    "Investicija"  CHAR(1),
    "PraData"      DATE,
    "PrekesID"     INTEGER,
    "DokPozNr"     INTEGER,
    "SN00"         VARCHAR(20),
    "SN01"         VARCHAR(20),
    "SN08"         VARCHAR(20),
    "SN09"         VARCHAR(20),
    "SN6"          VARCHAR(20)
);





/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE "turtas" ADD CONSTRAINT "turtas_PI" PRIMARY KEY ("ID");


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX "turtas_SI_Data" ON "turtas" ("Data");
CREATE INDEX "turtas_SI_Kodas" ON "turtas" ("Kodas");

/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/

CREATE TABLE "turto_irasai" (
    "ID"          INTEGER NOT NULL,
    "PraData"     DATE NOT NULL,
    "GalData"     DATE,
    "P"           CHAR(1),
    "PraVerte"    DECIMAL(12,2),
    "GalVerte"    DECIMAL(12,2),
    "MMetodas"    CHAR(1),
    "FMetodas"    CHAR(1),
    "Atsakingas"  INTEGER,
    "Pastabos"    VARCHAR(100),
    "NusVerte"    DECIMAL(12,2),
    "Vieta"       VARCHAR(50)
);





/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE "turto_irasai" ADD CONSTRAINT "tirasai_PI" PRIMARY KEY ("ID", "PraData");

/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/

CREATE TABLE "turtodi" (
    "ID"      INTEGER NOT NULL,
    "OpData"  DATE
);





/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE "turtodi" ADD CONSTRAINT "turtodi_PI" PRIMARY KEY ("ID");


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX "turtodi_SI_Data" ON "turtodi" ("OpData");
