{
Mokjimo pavedimas:
  Suma      - suma
  Bankas    - Banko sskaita (271)
  ArPriskaitymas - True/False
  Firma     - Tiekejo/Kliento sskaitos
  arba
  Bankas2   - antro banko sskaitos, jei pavedimas  savo antr sskait
  arba
  Darbuotojas - Darbuotojo sskaita

  dengimai:
  SNK,K_Debetas       - kliento skolos saskaita ir suma
  SNKA,KA_Debetas     - kliento avanso saskaita ir suma
  SNT,T_Debetas       - skolos tiekejui saskaita ir suma
  SNTA,TA_Debetas     - avanso tiekejui saskaita ir suma

  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  (2/4) Firma                  | (271) Bankas                | Suma
  arba (271) Bankas2
  arba Darbuotojas
  -----------------------------|-----------------------------|----------------------------
  K_Debetas                    | Bankas                      | SNK
  KA_Debetas                   | Bankas                      | SNKA
  T_Debetas                    | Bankas                      | SNT
  TA_Debetas                   | Bankas                      | SNTA

}
{
Rezultatas:
   [x]     - grup
   [x+1]   - debetas
   [x+2]   - kreditas
   [x+3]   - suma
}

function Operacija(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikms: VarArray [0..N] of variant
  ): Variant;

var
  rez: Variant;
  Suma: currency;
  Bankas: string;
  Firma: string;
  Bankas2: string;
  Darbuotojas: string;
  ArPriskaitymas: boolean;
  Priskaitymas: string;
  iIndex: integer;
  SNK, SNKA, SNT, SNTA: string;
  K_Debetas,KA_Debetas,T_Debetas,TA_Debetas: currency;

  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i:=VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Break;
      end;
    end;
  end;

begin
  Suma := Rasti('Suma');
  Bankas := Rasti('Bankas');
  Bankas2 := Rasti('Bankas2');
  Firma := Rasti('Firma');
  Darbuotojas := Rasti('Darbuotojas');
  ArPriskaitymas := Rasti('ArPriskaitymas');
  Priskaitymas := Rasti('Priskaitymas');
  SNK := Rasti('SNK');
  SNKA := Rasti('SNKA');
  SNT := Rasti('SNT');
  SNTA := Rasti('SNTA');
  K_Debetas := Rasti('K_Debetas');
  KA_Debetas := Rasti('KA_Debetas');
  T_Debetas := Rasti('T_Debetas');
  TA_Debetas := Rasti('TA_Debetas');

  if ArPriskaitymas and (Priskaitymas <> '') then begin
    rez := VarArrayCreate([0,3], varVariant);
    rez[0] := 1;
    rez[1] := Priskaitymas;  // debetas
    rez[2] := Bankas;    // kreditas
    rez[3] := Suma;
    Result := rez;
    Exit;
  end;

  if (Darbuotojas = '') and (Bankas2 = '') and (Firma = '') then begin
    rez := VarArrayCreate([0,0], varVariant);
    Result := rez;
    Exit;
  end;

  iIndex := 0;
  if K_Debetas > 0 then Inc(iIndex);
  if KA_Debetas > 0 then Inc(iIndex);
  if T_Debetas > 0 then Inc(iIndex);
  if TA_Debetas > 0 then Inc(iIndex);
  if iIndex = 0 then begin
    rez := VarArrayCreate([0,3], varVariant);
    rez[0] := 1;
    if Darbuotojas <> ''  then rez[1] := Darbuotojas  // debetas
    else if Bankas2 <> '' then rez[1] := Bankas2      // debetas - pavedimas sau
    else if Firma <> ''   then rez[1] := Firma;       // debetas
    rez[2] := Bankas;    // kreditas
    rez[3] := Suma;
  end else begin
    rez := VarArrayCreate([0,iIndex*4-1], varVariant);
    iIndex := 0;
    if K_Debetas > 0 then begin
      rez[iIndex+0] := 1;
      rez[iIndex+1] := SNK;
      rez[iIndex+2] := Bankas;
      rez[iIndex+3] := K_Debetas;
      iIndex := iIndex + 4;
    end;
    if KA_Debetas > 0 then begin
      rez[iIndex+0] := 1;
      rez[iIndex+1] := SNKA;
      rez[iIndex+2] := Bankas;
      rez[iIndex+3] := KA_Debetas;
      iIndex := iIndex + 4;
    end;
    if T_Debetas > 0 then begin
      rez[iIndex+0] := 1;
      rez[iIndex+1] := SNT;
      rez[iIndex+2] := Bankas;
      rez[iIndex+3] := T_Debetas;
      iIndex := iIndex + 4;
    end;
    if TA_Debetas > 0 then begin
      rez[iIndex+0] := 1;
      rez[iIndex+1] := SNTA;
      rez[iIndex+2] := Bankas;
      rez[iIndex+3] := TA_Debetas;
      iIndex := iIndex + 4;
    end;
  end;
  Result := rez;
end;

begin
end.


