{
Pardavimo grinimas:
  Klientas          - Kliento sskaitos (24/46)
  Moketinas_PVM     - Moketino PVM sskaita (4701)
  Gautinas_PVM      - Gautino PVM sskaita (251)

  Suma_be_PVM       - suma be PVM
  PVM_suma          - PVM suma
  Suma              - viso suma su PVM

  Pajamos[1]        - Pardavim ir paslaug pajam sskaitos (5)
  Pajamu_suma[1]    - Pardavim ir paslaug pajam suma

  Sanaudos[2],
  Savikaina[2]      - Snaud/savikainos sskaitos (6)
  Sanaudu_suma[2],
  Savikainos_suma[2] - Snaud/savikainos suma

  Atsargos[2]       - Atsarg sskaitos (2)
  Atsargu_suma[2]   - Atsarg suma

  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  (4701) Moketinas_PVM         | (45)/(22) Klientas          | PVM_suma
  (5) Pajamos [1]              | (45)/(22) Klientas          | Pajamu_suma [1]
  -----------------------------|-----------------------------|----------------------------
  (2) Atsargos [2]             | (6) Savikaina [2]           | Savikainos_suma [2]

  viso rau: 1 + [1] + [2]
}
{
Rezultatas:
   [x]     - grup
   [x+1]   - debetas
   [x+2]   - kreditas
   [x+3]   - suma
}

function Operacija(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikms: VarArray [0..N] of variant
  ): Variant;

var
  rez: Variant;

  Suma_be_PVM: currency;
  PVM_suma: currency;
  Suma: currency;

  Pajamu_suma: Variant;
  Savikainos_suma: Variant;
  Sanaudu_suma: Variant;
  Atsargu_suma: Variant;

  Pajamos: Variant;
  Sanaudos: Variant;
  Savikaina: Variant;
  Atsargos: Variant;

  Klientas: string;
  Gautinas_PVM: string;
  Moketinas_PVM: string;

  iIndex: integer;
  i1: integer;
  i2: integer;
  i: integer;

  v: Variant;

  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i := VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Exit;
      end;
    end;
    ShowMessage(Kas + ' = Unassigned');
  end;

  procedure VarToVarArray(var v:variant);
  var
    vTmp: variant;
  begin
    if (VarType(v) and varArray) = 0 then begin
      vTmp := v;
      v := VarArrayCreate([0,0], varVariant);
      v[0] := vTmp;
    end;
  end;

begin
  Suma_be_PVM := Rasti('Suma_be_PVM');
  PVM_suma := Rasti('PVM_suma');
  Suma := Rasti('Suma');

  Pajamu_suma := Rasti('Pajamu_suma');
  Savikainos_suma := Rasti('Savikainos_suma');
  Sanaudu_suma := Rasti('Sanaudu_suma');
  Atsargu_suma := Rasti('Atsargu_suma');

  VarToVarArray(Pajamu_suma);
  VarToVarArray(Savikainos_suma);
  VarToVarArray(Sanaudu_suma);
  VarToVarArray(Atsargu_suma);

  Pajamos := Rasti('Pajamos');
  Sanaudos := Rasti('Sanaudos');
  Savikaina := Rasti('Savikaina');
  Atsargos := Rasti('Atsargos');

  VarToVarArray(Pajamos);
  VarToVarArray(Sanaudos);
  VarToVarArray(Savikaina);
  VarToVarArray(Atsargos);

  i1 := VarArrayHighBound(Pajamos,1)-VarArrayLowBound(Pajamos,1)+1;
  i2 := VarArrayHighBound(Atsargos,1)-VarArrayLowBound(Atsargos,1)+1;

  Klientas := Rasti('Klientas');
  Moketinas_PVM := Rasti('Moketinas_PVM');
  Gautinas_PVM := Rasti('Gautinas_PVM');

  rez := VarArrayCreate([0,(1+i1+i2)*4-1], varVariant);

  iIndex := 0;
  // Debetas                      | Kreditas                    | suma
  // -----------------------------|-----------------------------|----------------------------
  // (4701) Moketinas_PVM         | (45)/(22) Klientas          | PVM_suma
  if PVM_suma > 0 then begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := Moketinas_PVM;   // debetas
    rez[iIndex+2] := Klientas;        // kreditas
    rez[iIndex+3] := PVM_suma;
    iIndex := iIndex + 4;
  end;
  // (5) Pajamos [1]              | (45)/(22) Klientas          | Pajamu_suma [1]
  for i := 0 to i1-1 do begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := Pajamos[i];      // debetas
    rez[iIndex+2] := Klientas;        // kreditas
    rez[iIndex+3] := Pajamu_suma[i];
    iIndex := iIndex + 4;
  end;
  // (2) Atsargos [2]             | (6) Savikaina [2]           | Savikainos_suma [2]
  for i := 0 to i2-1 do begin
    rez[iIndex+0] := 2;
    rez[iIndex+1] := Atsargos[i];      // debetas
    rez[iIndex+2] := Savikaina[i];     // kreditas
    rez[iIndex+3] := Savikainos_suma[i];
    iIndex := iIndex + 4;
  end;

  Result := rez;
end;

begin
end.

