{
Skol kortels raas
  BalansineSaskaita - balansin sskaita
  K              - Kliento skolos sskaita
  K_Debeto_suma  - Kliento skolos debeto suma
  K_Kredito_suma - Kliento skolos kredito suma
  KA             - Kliento avans sskaita
  KA_Debeto_suma  - Kliento avans debeto suma
  KA_Kredito_suma - Kliento avans kredito suma
  T              - Tiekejui skolos sskaita
  T_Debeto_suma  - Tiekejui skolos debeto suma
  T_Kredito_suma - Tiekejui skolos kredito suma
  TA              - Tiekejui avans sskaita
  TA_Debeto_suma  - Tiekejui avans debeto suma
  TA_Kredito_suma - Tiekejui avans kredito suma

  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  K                            | BalansineSaskaita           | K_Debeto_suma
  BalansineSaskaita            | K                           | K_Kredito_suma
  KA                           | BalansineSaskaita           | KA_Debeto_suma
  BalansineSaskaita            | KA                          | KA_Kredito_suma
  T                            | BalansineSaskaita           | T_Debeto_suma
  BalansineSaskaita            | T                           | T_Kredito_suma
  TA                           | BalansineSaskaita           | TA_Debeto_suma
  BalansineSaskaita            | TA                          | TA_Kredito_suma
}
{
Rezultatas:
   [x]     - grup
   [x+1]   - debetas
   [x+2]   - kreditas
   [x+3]   - suma
}

function Operacija(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikms: VarArray [0..N] of variant
  ): Variant;

var
  rez: Variant;
  BalansineSaskaita: string;
  K_Debeto_suma: currency;
  K_Kredito_suma: currency;
  KA_Debeto_suma: currency;
  KA_Kredito_suma: currency;
  T_Debeto_suma: currency;
  T_Kredito_suma: currency;
  TA_Debeto_suma: currency;
  TA_Kredito_suma: currency;
  K: string;
  KA: string;
  T: string;
  TA: string;

  iIndex: integer;

  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i:=VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Break;
      end;
    end;
  end;

begin
  BalansineSaskaita := Rasti('BalansineSaskaita');
  K := Rasti('K');
  KA := Rasti('KA');
  T := Rasti('T');
  TA := Rasti('TA');
  K_Debeto_suma := Rasti('K_Debeto_suma');
  K_Kredito_suma := Rasti('K_Kredito_suma');
  KA_Debeto_suma := Rasti('KA_Debeto_suma');
  KA_Kredito_suma := Rasti('KA_Kredito_suma');
  T_Debeto_suma := Rasti('T_Debeto_suma');
  T_Kredito_suma := Rasti('T_Kredito_suma');
  TA_Debeto_suma := Rasti('TA_Debeto_suma');
  TA_Kredito_suma := Rasti('TA_Kredito_suma');

  iIndex := 0;
  if (K_Debeto_suma > 0) then iIndex := iIndex + 4;
  if (K_Kredito_suma > 0) then iIndex := iIndex + 4;
  if (KA_Debeto_suma > 0) then iIndex := iIndex + 4;
  if (KA_Kredito_suma > 0) then iIndex := iIndex + 4;
  if (T_Debeto_suma > 0) then iIndex := iIndex + 4;
  if (T_Kredito_suma > 0) then iIndex := iIndex + 4;
  if (TA_Debeto_suma > 0) then iIndex := iIndex + 4;
  if (TA_Kredito_suma > 0) then iIndex := iIndex + 4;

  if iIndex = 0 then begin
    rez := VarArrayCreate([0,0], varVariant);
    Result := rez;
    Exit;
  end;

  rez := VarArrayCreate([0,iIndex-1], varVariant);

  iIndex := 0; 

  if (K_Debeto_suma > 0) then begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := K;    // debetas
    rez[iIndex+2] := BalansineSaskaita;  // kreditas
    rez[iIndex+3] := K_Debeto_suma;
    iIndex := iIndex + 4;
  end;
  if (K_Kredito_suma > 0) then begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := BalansineSaskaita;    // debetas
    rez[iIndex+2] := K;  // kreditas
    rez[iIndex+3] := K_Kredito_suma;
    iIndex := iIndex + 4;
  end;

  if (KA_Debeto_suma > 0) then begin
    rez[0] := 1;
    rez[1] := KA;    // debetas
    rez[2] := BalansineSaskaita;  // kreditas
    rez[3] := KA_Debeto_suma;
    iIndex := iIndex + 4;
  end;
  if (KA_Kredito_suma > 0) then begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := BalansineSaskaita;    // debetas
    rez[iIndex+2] := KA;  // kreditas
    rez[iIndex+3] := KA_Kredito_suma;
    iIndex := iIndex + 4;
  end;

  if (T_Debeto_suma > 0) then begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := T;    // debetas
    rez[iIndex+2] := BalansineSaskaita;  // kreditas
    rez[iIndex+3] := T_Debeto_suma;
    iIndex := iIndex + 4;
  end;
  if (T_Kredito_suma > 0) then begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := BalansineSaskaita;    // debetas
    rez[iIndex+2] := T;  // kreditas
    rez[iIndex+3] := T_Kredito_suma;
    iIndex := iIndex + 4;
  end;

  if (TA_Debeto_suma > 0) then begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := TA;    // debetas
    rez[iIndex+2] := BalansineSaskaita;  // kreditas
    rez[iIndex+3] := TA_Debeto_suma;
    iIndex := iIndex + 4;
  end;
  if (TA_Kredito_suma > 0) then begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := BalansineSaskaita;    // debetas
    rez[iIndex+2] := TA;  // kreditas
    rez[iIndex+3] := TA_Kredito_suma;
    iIndex := iIndex + 4;
  end;

  Result := rez;

end;

begin
end.

